//Wheel is defined. We use sort of a hack since torque has an 8 wheel limit but we want 16, so the wheel dts is instead an axle with two wheel meshes on it (so 1 'wheel' is two wheels)
datablock WheeledVehicleTire(BlokoSubwayTire)
{
	shapeFile = "./shapes/BlokoSubwayWheel.dts";

	mass = 10;
	radius = 1;
	staticFriction = 2.5;
	kineticFriction = 2;
	restitution = 0.5;	

	lateralForce = 3000;
	lateralDamping = 700;
	lateralRelaxation = 0.01;

	longitudinalForce = 6000;
	longitudinalDamping = 1400;
	longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleData(BlokoSubwayvehicle)
{
    category = "Vehicles";
    displayName = " ";
    shapeFile = "./shapes/BlokoSubway.dts";
    emap = true;
    minMountDist = 3;
	
	isTrain = 1;
   
    numMountPoints = 18;
    mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";
	mountThread[4] = "sit";
	mountThread[5] = "sit";
	mountThread[6] = "sit";
	mountThread[7] = "sit";
	mountThread[8] = "sit";
	mountThread[9] = "root";
	mountThread[10] = "root";
	mountThread[11] = "root";
	mountThread[12] = "root";
	mountThread[13] = "root";
	mountThread[14] = "root";
	mountThread[15] = "root";
	mountThread[16] = "root";
	mountThread[17] = "root";
	mountThread[18] = "root";

    maxDamage = 200.00;
    destroyedLevel = 200.00;
    energyPerDamagePoint = 160;
    speedDamageScale = 1.04;
    collDamageThresholdVel = 20.0;
    collDamageMultiplier   = 0.02;

    massCenter = "0 0 0";

    maxSteeringAngle = 0;  // Maximum steering angle, should match animation
    integration = 4;           // Force integration time: TickSec/Rate

    //3rd person camera settings
    cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 8;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.3;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;

    useEyePoint = false;    

	defaultTire	= BlokoSubwayTire;
	defaultSpring = jeepSpring;        //We dont really need a specific string so we steal one from a default vehicle with high mass

    numWheels = 8;

    // Rigid Body
    mass = 800;        //This is pretty high, don't try it on small stuff with 4 or less wheels
    density = 5.0;
    drag = 1.6;
    bodyFriction = 0.6;
    bodyRestitution = 0.6;
    minImpactSpeed = 10;       // Impacts over this invoke the script callback
    softImpactSpeed = 10;      // Play SoftImpact Sound
    hardImpactSpeed = 15;      // Play HardImpact Sound
    groundImpactMinSpeed    = 10.0;

    // Engine
    engineTorque = 400;      // Engine power, this is really low but that makes sense for a train
    engineBrake = 100;        // Braking when throttle is 0, train rolls almost freely but does slow down a little
    brakeTorque = 800;        // When brakes are applied (spacebar), really stops the train quickly
    maxWheelSpeed = 100;       // Engine scale by current speed / max speed, this is currently limited by the mass of the vehicle at ~75 and not 100

    rollForce        = 0;
    yawForce        = 0;
    pitchForce        = 1000;
    rotationalDrag        = 0.2;

    // Energy
    maxEnergy = 100;
    jetForce = 3000;
    minJetEnergy = 30;
    jetEnergyDrain = 2;

    splash = vehicleSplash;
    splashVelocity = 4.0;
    splashAngle = 67.0;
    splashFreqMod = 300.0;
    splashVelEpsilon = 0.60;
    bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
    mediumSplashSoundVelocity = 10.0;   
    hardSplashSoundVelocity = 20.0;   
    exitSplashSoundVelocity = 5.0;
    
    // Sounds
    //jetSound = ScoutThrustSound;
    //engineSound = idleSound;
    squealSound = squealSound;        //sound that gets triggered when braking with spacebar
    softImpactSound = slowImpactSound;
    hardImpactSound = fastImpactSound;
    //wheelImpactSound = slowImpactSound;

    //explosion = VehicleExplosion;
    justcollided = 0;

    uiName = "Bloko Subway";
    rideable = true;
    lookUpLimit = 0.65;
    lookDownLimit = 0.45;

    paintable = true;
   
    damageEmitter[0] = VehicleBurnEmitter;
    damageEmitterOffset[0] = "0.0 0.0 0.0 ";
    damageLevelTolerance[0] = 0.99;

    damageEmitter[1] = VehicleBurnEmitter;
    damageEmitterOffset[1] = "0.0 0.0 0.0 ";
    damageLevelTolerance[1] = 1.0;

    numDmgEmitterAreas = 1;

    initialExplosionProjectile = jeepExplosionProjectile;
    initialExplosionOffset = 0;         //offset only uses a z value for now

    burnTime = 4000;

    finalExplosionProjectile = tankFinalExplosionProjectile;
    finalExplosionOffset = 0.5;          //offset only uses a z value for now


    minRunOverSpeed    = 10;   //how fast you need to be going to run someone over (do damage)
    runOverDamageScale = 20;     //when you run over someone, speed * runoverdamagescale = damage amt
    runOverPushScale   = 0;   //how hard a person you're running over gets pushed
};