//We run a continuous speedcheck to do a bunch of stuff like speed-related sound and driver direction
function BlokoSubwayvehicleSpeedCheck(%this, %obj)
{
    if(!isObject(%obj))
        return;
 
    %vehicle = %obj;
 
    %vehicle.speed = vectorDot(%vehicle.getVelocity(), %vehicle.getForwardVector());
    if(!%vehicle.oldSpeed)
        %vehicle.oldSpeed = %vehicle.speed;
 
    %vehicle.oldSpeed = %vehicle.speed;
 
	if(%vehicle.speed >=-1)			//Is the train going forward?
	{
		%vehicle.playThread(3, rotfront);		//Play a 1-frame animation rotating mount0 (driver) and mount15 (guy standing next to driver) to the front cab
		%obj.hideNode(HL_Backwards);				//Hide and show the proper 'light' nodes on the front side of the train
		%obj.unhideNode(HL_Normal);
	}
	else
	{
		%vehicle.playThread(3, rotback);		//If the train is going backwards, play 1-frame animation rotating mount0 and mount15 180 degrees to the other side of the train
		%obj.unhideNode(HL_Backwards);				//Hide and show the proper 'light' nodes on the front side of the train
		%obj.hideNode(HL_Normal);
	}
 
    if(%applyBrakes)		//Play the squeal sound if braking
        %vehicle.playAudio(1, squealSound);
    if(!%applyBrakes)		//Stop playing that sound if we're no longer braking
        %vehicle.stopAudio(1);
		
	schedule(1000,0,"BlokoSubwayvehicleSpeedCheck",%this,%obj);
}
 
function BlokoSubwayvehicle::onAdd(%this, %obj)
{
    parent::onadd(%this,%obj);
	
    BlokoSubwayvehicleSpeedCheck(%this, %obj);

	%obj.hideNode(HL_Wht_0);
	%obj.unhideNode(HL_Wht_1);
	%obj.unhideNode(HL_Red_0);
	%obj.hideNode(HL_Red_1);
	
	%obj.hideNode(TL_Wht_1);
	%obj.unhideNode(TL_Wht_0);
	%obj.unhideNode(TL_Red_1);
	%obj.hideNode(TL_Red_0);
	
	%obj.Ldoor = "closed";
	%obj.Rdoor = "closed";
}

function BlokoSubwayVehicle::onRemove(%data, %obj)
{
	cancel(%obj.BlokoSubwayvehicleSpeedCheck);
}